<template>
  <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="客户编码" prop="customerCode">
            <el-input
              v-model="queryParams.customerCode"
              placeholder="请输入客户编码"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="客户名称" prop="customerName">
            <el-input
              v-model="queryParams.customerName"
              placeholder="请输入客户名称"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="手机" prop="mobile">
            <el-input
              v-model="queryParams.mobile"
              placeholder="请输入客户手机"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="所属部门" prop="deptId">
              <treeselect style="width:205.4px" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择所属部门" />
          </el-form-item>


          <el-form-item label="客户状态" prop="status">
            <el-select  v-model="queryParams.status" placeholder="请选择客户状态" clearable size="small">
              <el-option
                    v-for="item in statusOptions"
                    :key="item.dictValue"
                    :label="item.dictLabel"
                    :value="item.dictValue"
                  />
            </el-select>
          </el-form-item>

        <el-form-item label="跟进阶段" prop="visitStatus">
            <el-select  multiple filterable v-model="visitStatusArr" placeholder="请选择跟进阶段" clearable size="small">
              <el-option
                    v-for="item in visitStatusOptions"
                    :key="item.dictValue"
                    :label="item.dictLabel"
                    :value="item.dictValue"
                  />
            </el-select>
          </el-form-item>

          <el-form-item label="客户类型" prop="customerType">
            <el-select multiple filterable v-model="ctsTypeArr" placeholder="请选择客户类型" clearable size="small">
              <el-option
                    v-for="item in typeOptions"
                    :key="item.dictValue"
                    :label="item.dictLabel"
                    :value="item.dictValue"
                  />
            </el-select>
          </el-form-item>

          <el-form-item label="客户标签" prop="tags">
            <el-select multiple  filterable v-model="tagIds" placeholder="请选择客户标签" clearable size="small">
              <el-option
                    v-for="item in tagsOptions"
                    :key="item.dictLabel"
                    :label="item.dictLabel"
                    :value="item.dictLabel"
                  />
            </el-select>
          </el-form-item>

          <!-- <el-form-item label="是否认领" prop="isReceive">
            <el-select v-model="queryParams.isReceive" placeholder="请选择是否认领" clearable size="small">
              <el-option
                    v-for="item in receiveOptions"
                    :key="item.dictValue"
                    :label="item.dictLabel"
                    :value="item.dictValue"
                  />
            </el-select>
          </el-form-item> -->

          <el-form-item label="创建时间" prop="createTime">
            <el-date-picker
              style="width:205.4px"
              clearable size="small"
              v-model="dateRange"
              type="daterange"
              value-format="yyyy-MM-dd"
              start-placeholder="开始日期"
              end-placeholder="结束日期">
            </el-date-picker>
          </el-form-item>
          <el-form-item label="客户来源" prop="source">
            <el-select multiple filterable v-model="sourceArr" placeholder="请选择客户来源" clearable size="small">
              <el-option
                    v-for="item in sourceOptions"
                    :key="item.dictValue"
                    :label="item.dictLabel"
                    :value="item.dictValue"
                  />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
          <el-button
            type="success"
            icon="el-icon-edit"
            size="mini"
            :disabled="multiple"
            @click="handleAssign"
            v-hasPermi="['crm:customer:assignToUser']"
          >客户分配</el-button>
        </el-col>
        <el-col :span="1.5">
            <el-button
              type="success"
              size="mini"
              @click="handleAssignList"
              v-hasPermi="['crm:customerAssign:list']"
            >分配历史记录</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              type="warning"
              icon="el-icon-download"
              size="mini"
              @click="handleExport"
              v-hasPermi="['crm:customer:export']"
            >导出</el-button>
          </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
        <el-tabs type="card" v-model="queryParams.isReceive" @tab-click="handleClick">
          <el-tab-pane label="未领取" name="0"></el-tab-pane>
          <el-tab-pane label="已领取" name="1"></el-tab-pane>
        </el-tabs>
        <el-table  height="500" border v-loading="loading" :data="customerList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="客户编码" align="center" prop="customerCode" />
          <el-table-column  label="客户名称"   align="center" prop="customerName" :show-overflow-tooltip="true">
            <template slot-scope="scope">
              <el-link @click="handleShow(scope.row)" :underline="false" type="primary" >{{scope.row.customerName}}</el-link>
            </template>
          </el-table-column>
          <el-table-column  label="手机" width="120px"  align="center" prop="mobile"   >
            <template slot-scope="scope">
              {{scope.row.mobile}}
            </template>
          </el-table-column>
          <el-table-column  label="客户来源" align="center" prop="source">
            <template slot-scope="scope">
                <el-tag prop="status" v-for="(item, index) in sourceOptions"    v-if="scope.row.source==item.dictValue">{{item.dictLabel}}</el-tag>
            </template>
          </el-table-column>
          <el-table-column  label="跟进阶段"  align="center" prop="visitStatus">
            <template slot-scope="scope">
                <el-tag prop="visitStatus" v-for="(item, index) in visitStatusOptions"    v-if="scope.row.visitStatus==item.dictValue">{{item.dictLabel}}</el-tag>
              </template>
          </el-table-column>
          <el-table-column  label="客户类型"  align="center" prop="customerType">
            <template slot-scope="scope">
                <el-tag prop="status" v-for="(item, index) in typeOptions"    v-if="scope.row.customerType==item.dictValue">{{item.dictLabel}}</el-tag>
            </template>
          </el-table-column>
          <el-table-column label="标签" align="center" prop="tags" />
          <el-table-column  label="备注" align="center" prop="remark" width="200px" />
          <el-table-column label="进线客户详情" align="center" :show-overflow-tooltip="true" prop="registerDesc" />
          <el-table-column label="领取时间" align="center" prop="startTime" />
          <el-table-column label="进线客户提交日期" align="center" prop="registerSubmitTime" />
          <el-table-column label="创建时间" align="center" prop="createTime" width="180">
          </el-table-column>
          <el-table-column  label="认领人"  align="center" prop="companyUserNickName" :show-overflow-tooltip="true">
          </el-table-column>
          <el-table-column label="最后一次跟进时间" align="center" prop="receiveTime" width="120">
          </el-table-column>
          <el-table-column label="入公海时间" align="center" prop="poolTime" width="120">
          </el-table-column>
          <el-table-column label="操作"   align="center" fixed="right" width="120px" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <!-- <el-button
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="handleUpdate(scope.row)"
                v-hasPermi="['crm:customer:edit']"
              >修改</el-button> -->
              <el-button
                size="mini"
                type="text"
                @click="handleShow(scope.row)"
                v-hasPermi="['crm:customer:query']"
              >查看</el-button>
              <el-button
              v-if="scope.row.isReceive==0"
                size="mini"
                type="text"
                @click="handleReceive(scope.row)"
                v-hasPermi="['crm:customer:receive']"
              >认领</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />



    <el-drawer
      size="75%"
      :title="show.title" :visible.sync="show.open"
      >
        <customer-details  ref="customerDetails" />
    </el-drawer>
    <el-dialog :title="assignList.title" :visible.sync="assignList.open" width="1000px" append-to-body>
      <customer-assign-list  ref="assignList" @close="closeAssignList"></customer-assign-list>
    </el-dialog>
    <el-dialog :title="assign.title" :visible.sync="assign.open" width="800px" append-to-body>
        <assign-user  ref="assignUser" @close="closeAssign"   />
    </el-dialog>


  </div>
</template>

<script>

import { assignToUser,receive,getFullCustomerList,addCustomer,updateCustomer,getCustomerDetails,exportCustomer  } from "@/api/crm/customer";
import customerDetails from '../components/customerDetails.vue';
import {getCitys} from "@/api/store/city";
import { treeselect } from "@/api/company/companyDept";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import customerAssignList from '../components/customerAssignList.vue';
import assignUser from '../components/assignUser.vue';
export default {
  name: "Customer",
  components: {customerAssignList, customerDetails,Treeselect,assignUser },
  data() {
    return {
      visitStatusOptions:[],
      tagIds:[],
      tagsOptions:[],
      visitStatusArr:[],
      ctsTypeArr:[],
      sourceArr:[],
      userSelect:{
        title:"选择员工",
        open:false,
      },
      assign:{
        title:"分配客户",
        open:false,
      },
      // 表单校验
      assignRules: {
        // companyUserId: [
        //   { required: true, message: "员工不能为空", trigger: "blur" }
        // ],
      },
      users:[],
      assignList:{
        title:"分配历史记录",
        open:false,
      },
      dateRange:[],
      defaultProps: {
        children: "children",
        label: "label",
      },
      // 部门树选项
      deptOptions: undefined,
      // 部门名称
      deptName: undefined,
      cityIds:[],
      citys:[],
      tags:[],
      inputVisible: false,
      inputValue: '',
      receiveOptions:[],
      statusOptions:[],
      typeOptions:[],
      sourceOptions:[],
      sexOptions:[],
      show:{
        title:"客户详情",
        open:false,
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 客户表格数据
      customerList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        customerCode: null,
        customerName: null,
        mobile: null,
        sex: null,
        weixin: null,
        userId: null,
        createUserId: null,
        receiveUserId: null,
        customerUserId: null,
        address: null,
        location: null,
        detailAddress: null,
        lng: null,
        lat: null,
        status: null,
        isReceive: null,
        deptId: null,
        isDel: null,
        customerType: null,
        receiveTime: null,
        poolTime: null,
        companyId: null,
        isLine: null,
        source: null,
        tags: null
      },
      // 表单参数
      form: {
        province:null,
        city:null,
        district:null,
      },
      // 表单校验
      rules: {
        customerName: [
          { required: true, message: "客户名称不能为空", trigger: "blur" }
        ],
        mobile: [
          { required: true, message: "手机号不能为空", trigger: "blur" }
        ],
        sex: [
          { required: true, message: "性别不能为空", trigger: "blur" }
        ],
        source: [
          { required: true, message: "客户来源不能为空", trigger: "blur" }
        ],
      }
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    },
  },
  created() {
    this.getDicts("crm_customer_user_status").then((response) => {
      this.visitStatusOptions = response.data;
    });
    this.getDicts("crm_customer_source").then((response) => {
      this.sourceOptions = response.data;
    });
    this.getDicts("sys_sex").then((response) => {
      this.sexOptions = response.data;
    });
    this.getDicts("crm_customer_source").then((response) => {
      this.sourceOptions = response.data;
    });
    this.getDicts("sys_sex").then((response) => {
      this.sexOptions = response.data;
    });
    this.getDicts("crm_customer_status").then((response) => {
      this.statusOptions = response.data;
    });
    this.getDicts("crm_customer_type").then((response) => {
      this.typeOptions = response.data;
    });
    this.getDicts("crm_customer_is_receive").then((response) => {
      this.receiveOptions = response.data;
    });
    this.getDicts("crm_customer_tag").then((response) => {
        this.tagsOptions = response.data;
    });
    this.getTreeselect();
    this.getCitys();
    this.getList();
  },
  methods: {
    handleShow(row){
      this.show.open=true;
      var that=this;
      setTimeout(() => {
        that.$refs.customerDetails.getDetails(row.customerId);
      }, 200);
    },
    handleAssign(){
      var that=this;
      var ids=this.ids;
      that.assign.open=true;
      setTimeout(() => {
          if(that.queryParams.isReceive=="0"){
            that.$refs.assignUser.init(ids,2);
          }
          else if(that.queryParams.isReceive=="1"){
            that.$refs.assignUser.init(ids,3);
          }

      }, 200);
    },
    closeAssign(){
      this.assign.open=false;
      this.getList();
    },
    handleAssignList(){
      this.assignList.open=true;
      var that=this;
      setTimeout(() => {
        that.$refs.assignList.getData();
      }, 200);
    },
    closeAssignList(){
      this.assignList.open=false;
      this.getList();
    },
    handleClick(tab, event) {
      this.queryParams.isReceive=tab.name;
      this.getList();
    },
    handleReceive(row) {
      this.$confirm('是否确认认领客户"' + row.customerName + '"?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          var data={customerId:row.customerId}
          return receive(data);
        }).then(() => {
          this.getList();
          this.msgSuccess("操作成功");
        }).catch(function() {});
    },
    getTreeselect() {
      treeselect().then((response) => {
        this.deptOptions = response.data;
      });
    },
    handleCityChange(value) {
      console.log(value);
      var nodes=this.$refs.citySelect.getCheckedNodes();
      this.form.address=nodes[0].pathLabels[0]+"-"+nodes[0].pathLabels[1]+"-"+nodes[0].pathLabels[2];
      this.form.cityIds=value.toString();
      console.log(this.form.address);
    },
    getCitys(){
        getCitys().then(res => {
          this.loading = false;
          this.citys=res.data;
        })
    },
    /** 查询客户列表 */
    getList() {
      this.loading = true;

      if(this.visitStatusArr.length>0){
        this.queryParams.visitStatus=this.visitStatusArr.toString();
      }
      else{
        this.queryParams.visitStatus=null
      }

      if(this.ctsTypeArr.length>0){
        this.queryParams.customerType=this.ctsTypeArr.toString();
      }
      else{
        this.queryParams.customerType=null
      }

      if(this.sourceArr.length>0){
        this.queryParams.source=this.sourceArr.toString();
      }
      else{
        this.queryParams.source=null
      }


      if(this.tagIds.length>0){
        this.queryParams.tags=this.tagIds.toString();
      }
      else{
        this.queryParams.tags=null
      }
      getFullCustomerList(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.customerList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        customerId: null,
        customerCode: null,
        customerName: null,
        mobile: null,
        sex: null,
        weixin: null,
        remark: null,
        userId: null,
        createUserId: null,
        receiveUserId: null,
        customerUserId: null,
        address: null,
        location: null,
        detailAddress: null,
        lng: null,
        lat: null,
        createTime: null,
        updateTime: null,
        status: 0,
        isReceive: null,
        deptId: null,
        isDel: null,
        customerType: null,
        receiveTime: null,
        poolTime: null,
        companyId: null,
        isLine: null,
        source: null,
        tags: null
      };
      this.tags=[];
      this.cityIds=[];
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.visitStatusArr =  [];
      this.tagIds =  [];
      this.dateRange = [];
      this.sourceArr  =  [];
      this.ctsTypeArr =  [];
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.customerId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加客户";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      var that=this;
      this.reset();
      const customerId = row.customerId || this.ids.toString()
      var data={customerId:customerId}
      getCustomerDetails(data).then(response => {
        this.form = response.data;
        if(this.form.status!=null){
          this.form.status = this.form.status.toString();
        }
        if(this.form.customerType!=null){
          this.form.customerType = this.form.customerType.toString();
        }
        if(this.form.sex!=null){
          this.form.sex = this.form.sex.toString();
        }
        if(this.form.source!=null){
          this.form.source = this.form.source.toString();
        }
        if(this.form.tags!=null){
          this.tags = this.form.tags.split(",")
        }
        console.log(this.form.cityIds)
        if(this.form.cityIds!=null){
          var ids=this.form.cityIds.split(",");
          this.cityIds=[];
          ids.forEach(element => {
              var id=parseInt(element);
              that.cityIds.push(id)
          });
        }
        this.open = true;
        this.title = "修改客户";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.customerId != null) {
            updateCustomer(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addCustomer(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const customerIds = row.customerId || this.ids;
      this.$confirm('是否确认删除客户编号为"' + customerIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delLineCustomer(customerIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有客户数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportCustomer(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    },
  }
};
</script>
<style>
  .el-tag + .el-tag {
    margin-left: 10px;
  }
  .button-new-tag {
    margin-left: 10px;
    height: 32px;
    line-height: 30px;
    padding-top: 0;
    padding-bottom: 0;
  }
  .input-new-tag {
    width: 90px;
    margin-left: 10px;
    vertical-align: bottom;
  }
  .el-dialog__wrapper{
    z-index: 100000;
  }
</style>
